#include <gtk/gtk.h>
#include <string.h>
#include <ctype.h>

#include "phone.h"
#include "ansiterm.h"
#include "modem.h"
#include "status.h"
#include "config.h"
#include "gau.h"



GtkWidget *edit_entry[4];
int ntry;
GList * item_list;
int dial_timeout_tag = -1;
int dial_next_tag = -1;

void dial_next(void);
gint wait_response(char *buf, int bytes);
static int call_timeout_callback(gpointer data);
static void install_dial_next(void);

Phone *phone = NULL;
GtkWidget *phone_window = NULL;
PhoneItem *current_item = NULL;
GList *string_list = NULL;
typedef struct { char * filename; GtkWidget *widget;}StringData ;

void
add(GtkWidget *w, GtkWidget *p)
{
	PhoneItem *item = g_new0(PhoneItem, 1);
	phone_insert_item(PHONE(p), item, PHONE(p)->current);
}

void
del(GtkWidget *w, GtkWidget *p)
{
	if(PHONE(p)->nitem) phone_remove_nth_item(PHONE(p), PHONE(p)->current);
}

void
save(GtkWidget *w, GtkWidget *p)
{
	phone_file_save(PHONE(p), expand_path(PHONE_LIST));
}

static GtkWidget *
dial_edit_entry(char *name, GtkWidget *vbox)
{
	GtkWidget *label, *entry;
	GtkWidget *hbox = gtk_hbox_new(FALSE, 8);
	gtk_container_add(GTK_CONTAINER(vbox), hbox);
	gtk_widget_show(hbox);
	label = gtk_label_new(name);
	gtk_misc_set_alignment(GTK_MISC(label), 1.0, 0.5);
	gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
	gtk_widget_show(label);
	entry = gtk_entry_new();
	gtk_box_pack_end(GTK_BOX(hbox), entry, FALSE, FALSE, 0);
	gtk_widget_show(entry);
	return entry;
}

static void
dial_edit_ok_callback(GtkWidget *w, gpointer data)
{
	char *script_file;
	PhoneItem *item = current_item;
	g_free(item->name);
	item->name = g_strdup(gtk_entry_get_text(GTK_ENTRY(edit_entry[0])));
	g_free(item->phone_number);
	item->phone_number = g_strdup(gtk_entry_get_text(GTK_ENTRY(edit_entry[1])));
	g_free(item->speed);
	item->speed = g_strdup(gtk_entry_get_text(GTK_ENTRY(edit_entry[2])));
	script_file =item->script_file;
	item->script_file = g_strdup(gtk_entry_get_text(GTK_ENTRY(edit_entry[3])));
	g_free(script_file);
	gtk_widget_hide(gtk_widget_get_toplevel(w));
	gtk_widget_draw(phone_window, NULL);
}

static void
dial_edit_cancel_callback(GtkWidget *w, GtkWidget *win)
{
	gtk_widget_hide(win);
}

static void
edit(GtkWidget *w, Phone *phone)
{
	static GtkWidget *win = NULL;
	GtkWidget *vbox, *hbox;
	GtkWidget *frame;
	current_item = g_list_nth(phone->items, phone->current)->data;
	// g_print("current: %d\n", phone->current);
	// g_print("current_item = %p\n", current_item);
	if(win) {
		gtk_entry_set_text(GTK_ENTRY(edit_entry[0]), current_item->name);
		gtk_entry_set_text(GTK_ENTRY(edit_entry[1]), current_item->phone_number);
		gtk_entry_set_text(GTK_ENTRY(edit_entry[2]), current_item->speed);
		if(current_item->script_file)
			gtk_entry_set_text(GTK_ENTRY(edit_entry[3]), current_item->script_file);
		gtk_widget_show(win);
		return;
	}
	win = gtk_window_new(GTK_WINDOW_DIALOG);
	gtk_window_set_title(GTK_WINDOW(win), "ȭȣ ");
	gtk_container_border_width(GTK_CONTAINER(win), 5);
	frame = gtk_widget_new(gtk_frame_get_type(),
		"GtkWidget::parent", win,
		"GtkWidget::visible", TRUE,
		NULL);
	vbox = gtk_vbox_new(TRUE, 8);
	gtk_container_border_width(GTK_CONTAINER(vbox), 8);

	gtk_container_add(GTK_CONTAINER(frame), vbox);
	gtk_widget_show(vbox);
	edit_entry[0] = dial_edit_entry("̸:", vbox); 
	gtk_entry_set_text(GTK_ENTRY(edit_entry[0]), current_item->name);
	edit_entry[1] = dial_edit_entry("ȭȣ:", vbox); 
	gtk_entry_set_text(GTK_ENTRY(edit_entry[1]), current_item->phone_number);
	edit_entry[2] = dial_edit_entry("ۼӵ:", vbox); 
	gtk_entry_set_text(GTK_ENTRY(edit_entry[2]), current_item->speed);
	edit_entry[3] = dial_edit_entry("ȥڸ:", vbox); 
	if(current_item->script_file)
		gtk_entry_set_text(GTK_ENTRY(edit_entry[3]), current_item->script_file);
	gtk_widget_new(gtk_hseparator_get_type(),
		"GtkWidget::parent", vbox,
		"GtkWidget::visible", TRUE,
		NULL);
	hbox = gtk_hbox_new(TRUE, 5);
	gtk_container_add(GTK_CONTAINER(vbox), hbox);
	gtk_widget_show(hbox);
	gtk_widget_new(gtk_button_get_type(),
		"GtkButton::label", "Ȯ",
		"GtkObject::signal::clicked", dial_edit_ok_callback, NULL,
		"GtkWidget::parent", hbox,
		"GtkWidget::visible", TRUE,
		NULL);
	gtk_widget_new(gtk_button_get_type(),
		"GtkButton::label", "",
		"GtkObject::signal::clicked", dial_edit_cancel_callback, win,
		"GtkWidget::parent", hbox,
		"GtkWidget::visible", TRUE,
		NULL);
	gtk_widget_show(win);
}

static void
close_callback(GtkWidget *w, GtkWidget *window)
{
	gtk_widget_hide(window);
}

static void
select_callback(GtkWidget *w, Phone *phone)
{
	phone_selection_toggle(phone, phone->current);
}

void
dial_cancel(void)
{
	// g_print("%s\n", __FUNCTION__);
	input_filter_list = g_list_remove(input_filter_list, wait_response);
	modem_write(cancel_string, strlen(cancel_string));
	if(dial_timeout_tag  >= 0) gtk_timeout_remove(dial_timeout_tag);
	ntry = 0;
	dial_timeout_tag = -1;
	if(dial_next_tag > 0) gtk_timeout_remove(dial_next_tag);
	dial_next_tag = -1;
	current_item = NULL;
}

static void
monitor_response()
{
	// g_print("%s\n", __FUNCTION__);
	input_filter_list = g_list_append(input_filter_list, wait_response);

	// initialize the internal buffer used in wait_response
	wait_response(NULL, -1); 
}

gint
wait_response(char *buf, int bytes)
{
	static char response[20];
	static char *p = response;
	int i=0;
	static int log = FALSE;
	if(bytes < 0) {
		// initialize 
		p = response;
		log = FALSE;
		return TRUE;
	}
	//g_print("%s\n", __FUNCTION__);
	for(i=0;i<bytes;i++) {
		// g_print("'%c' %d\n", buf[i], buf[i]);
		if(buf[i] == 10) {
			if(log) {
				*p = 0;
				if(strstr(response, "BUSY") != 0) {
					show_message("ȭ");
					install_dial_next();
				} else if(strstr(response, "NO CARRIER") != 0 ||
				   strstr(response, "NO DIALTONE") != 0 ||
				   strstr(response, "OK") != 0 ||
				   strstr(response, "VOICE") != 0) {
					/* failure */
					// g_print("fail %s\n", __FUNCTION__);
					install_dial_next();
				} else {
					modem_check_connected(NULL);
					gtk_widget_hide(phone_window);
					// g_print("success %s\n", __FUNCTION__);
				}
				gtk_timeout_remove(dial_timeout_tag);
				dial_timeout_tag = -1;
				input_filter_list = g_list_remove(input_filter_list,
					wait_response); 
				p = response;
				log = FALSE;
				break;
			} else {
				log = TRUE;
			}
		} else {
			if(log) *p++ = buf[i];
		}
	}
	//g_print("%s leave\n", __FUNCTION__);
	return TRUE;
}

static int
dial_next_run(gpointer foo)
{
	// g_print("%s\n", __FUNCTION__);
	dial_next();
	dial_next_tag = -1;
	return FALSE;
}

static void
install_dial_next(void)
{
	gau_state = DIAL;
	// g_print("%s\n", __FUNCTION__);
	if(ntry++ > MAX_TRY) {
		show_message("ɸŭ ɾϴ");
		return;
	}
	dial_next_tag = gtk_timeout_add(5*1000, dial_next_run, NULL);
	show_message("5ʰ ٸϴ");
}

void
dial_next(void)
{
	PhoneItem *item;
	int i=0;
	// g_print(" %d %s\n", ntry+1,__FUNCTION__);
	gau_state = DIAL;
	if(phone->nitem == 0) {
		/* no selected number */
		show_message("no phone number");
		return;
	}

	while(1) {
		i++;
		item = item_list->data;
		if(item->state & PHONE_SELECTED) {
			if(item_list->next) item_list = item_list->next;
			else item_list = phone->items;
			dial_phone(item);
			return ;
		}
		if(item_list->next) item_list = item_list->next;
		else item_list = phone->items;
		if(i == phone->nitem) {
			gdk_beep();
			show_message(" ȭȣ ϼ!!!");
			return;
		}
	}
}

void
dial_phone(PhoneItem *item)
{
	char *number;
	char buf[256];
	if(item->speed) {
		modem_setbaud(read_fd, item->speed);
	} else {
		//g_warning("speed for this phone number is not set\n");
		// use default speed;
		modem_setbaud(read_fd, modem_speed);
	}
	number = item->phone_number;
	modem_write(call_prefix, strlen(call_prefix));
	while(*number) {
		if(isdigit(*number)) modem_write(number, 1);
		number++;
	}
	modem_write(call_suffix, strlen(call_suffix));
	sprintf(buf, "%d° õ: %s(%s) ȭ ̴ϴ", ntry, item->name, item->phone_number);
	show_message(buf);
	dial_timeout_tag = 
		gtk_timeout_add(30*1000, call_timeout_callback, item_list);
	monitor_response();
	current_item = item;
}

void
call_callback(GtkWidget *w, Phone *phone)
{
	item_list = phone->items;
	ntry = 1;
	dial_next();
}

int
call_timeout_callback(gpointer data)
{
	// g_print("%s\n", __FUNCTION__);
	show_message("ð ʰ");
	modem_write(cancel_string, strlen(cancel_string));

	dial_timeout_tag = -1;
	//install_dial_next();
	return FALSE;
}


GtkWidget *
dial_control_button(char *name, GtkSignalFunc func, gpointer data, GtkWidget *box)
{
	GtkWidget *button = gtk_button_new_with_label(name);
	GTK_WIDGET_UNSET_FLAGS(button, GTK_CAN_FOCUS);
	gtk_signal_connect(GTK_OBJECT(button), "clicked",
		func, data);
	gtk_container_add(GTK_CONTAINER(box), button);
	gtk_widget_show(button);
	return button;
}


void
dial_callback(GtkWidget *w, gpointer data)
{
	if(use_modem) {
		if(modem_connected()) {
			hangup_callback(w, data);
		} else 
			phone_win();
	} else {
		if(read_fd > 0) {
			hangup();
		}
	}
}

void
phone_win()
{
	GtkWidget *scrolled_win;
	GtkWidget *vbox;
	GtkWidget *hbox;
	GtkWidget *button;
	if(phone_window) {
		gtk_widget_show(phone_window);
		return;
	}
	phone_window = gtk_window_new(GTK_WINDOW_DIALOG);
	gtk_window_position(GTK_WINDOW(phone_window), GTK_WIN_POS_CENTER);
	gtk_window_set_title(GTK_WINDOW(phone_window), "ȭɱ");
	gtk_signal_connect(GTK_OBJECT(phone_window), "destroy",
		GTK_SIGNAL_FUNC(window_destroyed), &phone_window);
	vbox = gtk_vbox_new(FALSE, 4);
	gtk_container_add(GTK_CONTAINER(phone_window), vbox);
	gtk_widget_show(vbox);
	scrolled_win = gtk_scrolled_window_new(NULL, NULL);
	gtk_scrolled_window_set_policy((GtkScrolledWindow *)scrolled_win,
		GTK_POLICY_AUTOMATIC, GTK_POLICY_ALWAYS);
	gtk_container_add(GTK_CONTAINER(vbox), scrolled_win);
	gtk_widget_set_usize(scrolled_win, 530, 250);
	gtk_widget_show(scrolled_win);
	phone = (Phone *)phone_new_from_file(expand_path(PHONE_LIST));
	gtk_container_add(GTK_CONTAINER(scrolled_win), GTK_WIDGET(phone));
	gtk_widget_show(GTK_WIDGET(phone));
	gtk_widget_new(gtk_hseparator_get_type(),
		"GtkWidget::parent", vbox,
		"GtkWidget::visible", TRUE,
		NULL);
	hbox = gtk_hbox_new(TRUE, 5);
	gtk_container_add(GTK_CONTAINER(vbox), hbox);
	gtk_widget_show(hbox);

	button = dial_control_button("߰",
		GTK_SIGNAL_FUNC(add), phone, hbox);
	button = dial_control_button("",
		GTK_SIGNAL_FUNC(del), phone, hbox);
	button = dial_control_button("",
		GTK_SIGNAL_FUNC(save), phone, hbox);
	button = dial_control_button("",
		GTK_SIGNAL_FUNC(edit), phone, hbox);

	hbox = gtk_hbox_new(TRUE, 5);
	gtk_container_add(GTK_CONTAINER(vbox), hbox);
	gtk_widget_show(hbox);

	button = dial_control_button("ȭɱ",
		GTK_SIGNAL_FUNC(call_callback), phone, hbox);
	button = dial_control_button("",
		GTK_SIGNAL_FUNC(select_callback), phone, hbox);
	button = dial_control_button("ݱ",
		GTK_SIGNAL_FUNC(close_callback), phone_window, hbox);
	gtk_widget_show(phone_window);
}

void
restore_main_bottom_menu(void)
{
	update_bottom_menu_from_file("main");
}

#if 0
void
update_telnet_bottom_menu(void)
{
	if(telnetinfo == NULL || telnetinfo->bottom_file == NULL) {
		gtk_widget_set_sensitive(bottom_frame, FALSE);
		return;
	}
	update_bottom_menu_from_file(telnetinfo->bottom_file);
}


void
update_bottom_menu(void)
{
	if(use_modem && current_item == NULL) {
		gtk_widget_set_sensitive(bottom_frame, FALSE);
		return;
	}
	update_bottom_menu_from_file(current_item->bottom_file);
}
#endif


