/* GTK - The GIMP Toolkit
 * Copyright (C) 1995-1997 Peter Mattis, Spencer Kimball and Josh MacDonald
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
#ifndef __FIXED_LABEL_H__
#define __FIXED_LABEL_H__


#include <gdk/gdk.h>
#include <gtk/gtkmisc.h>


#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */


#define FIXED_LABEL(obj)          GTK_CHECK_CAST (obj, fixed_label_get_type (), FixedLabel)
#define FIXED_LABEL_CLASS(klass)  GTK_CHECK_CLASS_CAST (klass, fixed_label_get_type (), FixedLabelClass)
#define FIXED_IS_LABEL(obj)       GTK_CHECK_TYPE (obj, fixed_label_get_type ())


typedef struct _FixedLabel       FixedLabel;
typedef struct _FixedLabelClass  FixedLabelClass;

struct _FixedLabel
{
  GtkMisc misc;

  char *label;
};

struct _FixedLabelClass
{
  GtkMiscClass parent_class;
};

guint      fixed_label_get_type (void);
GtkWidget* fixed_label_new      (char      *str);
void       fixed_label_set      (FixedLabel  *label,
			       char      *str);
void       fixed_label_get      (FixedLabel  *label,
			       char     **str);


#ifdef __cplusplus
}
#endif /* __cplusplus */


#endif /* __GTK_LABEL_H__ */
