/* this file is a part of gau software, (C) Hwang chi-duck 1997               */

/*
 *
 *  α׷ ۱ Ȳġ ϴ.
 *  α׷ GNU GENERAL PUBLIC LICENSE ǰ ˴ϴ.
 *  α׷   ü, ,
 * ȸ س  ȭ  å ϴ.
 * 
 */

#include <gtk/gtk.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <signal.h>
#include <wait.h>
#include <string.h>

#include "ansiterm.h"
#include "modem.h"
#include "config.h"
#include "gau.h"

void resize_increment_set(GtkWidget *w, AnsiTerm *term);
char gau_version[] = "gau version 0.2";

extern char *basename(char *);
char tmpbuf[1024];

void input_handler(gpointer data, int source, GdkInputCondition con);
static void terminal_size_changed(AnsiTerm *term);
static void terminal_line_changed(AnsiTerm *term);

AnsiTerm *term;
int use_modem;/* internet or modem */
guint32 last_out_time = 0;

int gau_state = NOTHING;
GtkWidget *main_win;
GtkWidget *main_box, *control_box, *status_box;
GtkWidget *current_bottom_menu, *main_bottom_menu;
GtkWidget *bottom_frame;
int saved_lines = 200;
int read_tag = -1;
int read_fd = -1;// in fact, this fd is for read-write
int local_echo = FALSE;
int remote_echo = FALSE;
int col = 82, row = 26;
int normal_fg = 7;
int normal_bg = 4;
int read_hack = TRUE;
int can_block = TRUE;
int auto_linefeed = TRUE;
char *terminal_font = NULL;
int terminal_font_ascent = -1, terminal_font_height = -1;
int silent = FALSE;
char *editor = NULL;
char *sh_command = NULL;

GList *input_filter_list = NULL;
GList *disconnected_function_list = NULL;
GList *connected_function_list = NULL;


int
main(int argc, char *argv[])
{
	GtkWidget *hbox, *box, *frame, *sframe;
	GtkWidget *separator;
	int fd;
	int i;

	gtk_init(&argc, &argv);
	if(strcmp(basename(argv[0]),"gaui") == 0) {
		use_modem = FALSE;
	} else {
		use_modem = TRUE;
	}
	for(i=1;i<argc;i++) {
		if(strncmp(argv[i], "--modem", 7) == 0) {
			modem_device = g_strdup(argv[i+1]);
			i++;
		} else if(strncmp(argv[i], "--dial", 6) == 0) {
		} else if(argv[i][0] != '-') {
			if(!use_modem) {
				gtk_timeout_add(2000, (GtkFunction)connect_host_by_name, g_strdup(argv[i]));
			}
		}
	}


	gau_config();

	if(argc > 1) {
		if(argv[1][0] == '-') fd = 0;
		else fd = open(argv[1], O_RDONLY);
		gdk_input_add(fd, GDK_INPUT_READ, input_handler, NULL);
	} 
	
	if(use_modem) { /* communication through modem */
		modem_init();
		if(read_hack) {
			read_tag = gdk_input_add(read_fd,GDK_INPUT_READ, 
				fast_input_handler_from_external, NULL); 
		} else {
			read_tag = gdk_input_add(read_fd,GDK_INPUT_READ, 
				input_handler_from_external, NULL); 
		}
	}

	sprintf(tmpbuf, "%s/gau.log", expand_path(gau_path));
	log_file = fopen(tmpbuf, "a");
	auto_response_prepare();
	input_filter_list = g_list_append(input_filter_list, zmodem_input_filter);
	connected_function_list = g_list_append(
		connected_function_list, run_login_script); 

	main_win = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_policy(GTK_WINDOW(main_win), TRUE, TRUE, TRUE);
	gtk_window_position(GTK_WINDOW(main_win), GTK_WIN_POS_CENTER);
	gtk_signal_connect(GTK_OBJECT(main_win), "destroy",
		GTK_SIGNAL_FUNC(gtk_main_quit), NULL);
	gtk_window_set_title(GTK_WINDOW(main_win), "");
	gtk_widget_set_name(main_win, "main");
	gtk_container_border_width(GTK_CONTAINER(main_win), 5);

	main_box = gtk_vbox_new(FALSE, 3);
	gtk_container_add(GTK_CONTAINER(main_win), main_box);
	gtk_widget_show(main_box);

	hbox = gtk_hbox_new(FALSE, 5);
	gtk_container_add(GTK_CONTAINER(main_box), hbox);
	gtk_widget_show(hbox);

	sframe = gtk_frame_new(NULL);
	gtk_container_border_width(GTK_CONTAINER(sframe), 3);
	gtk_frame_set_shadow_type(GTK_FRAME(sframe), GTK_SHADOW_ETCHED_OUT);
	gtk_container_add(GTK_CONTAINER(hbox), sframe);
	gtk_widget_show(sframe);

	frame = gtk_frame_new(NULL);
	gtk_container_border_width(GTK_CONTAINER(frame), 1);
	gtk_frame_set_shadow_type(GTK_FRAME(frame), GTK_SHADOW_ETCHED_IN);
	gtk_container_add(GTK_CONTAINER(sframe), frame);
	gtk_widget_show(frame);

	box = gtk_hbox_new(FALSE, 0);
	gtk_container_add(GTK_CONTAINER(frame), box);
	gtk_widget_show(box);



	frame = gtk_frame_new(NULL);
	gtk_container_add(GTK_CONTAINER(box), frame);
	gtk_widget_show(frame);
	if(use_modem) {
		term = (AnsiTerm*)ansi_term_new(terminal_font, col, row, saved_lines, terminal_font_ascent, terminal_font_height, NULL, modem_write);
	} else {
		term = (AnsiTerm*)ansi_term_new(terminal_font, col, row, saved_lines, terminal_font_ascent, terminal_font_height, NULL, dumb);
	}
	gtk_signal_connect(GTK_OBJECT(term), "button_press_event",
		GTK_SIGNAL_FUNC(button_press_callback), NULL);
	gtk_signal_connect(GTK_OBJECT(term), "button_release_event",
		GTK_SIGNAL_FUNC(button_release_callback), NULL);
	gtk_signal_connect(GTK_OBJECT(term), "motion_notify_event",
		GTK_SIGNAL_FUNC(motion_callback), NULL);
	gtk_signal_connect(GTK_OBJECT(term), "size_changed",
		GTK_SIGNAL_FUNC(terminal_size_changed), NULL);
	if(n_inout) gtk_signal_connect(GTK_OBJECT(term), "line_changed",
		GTK_SIGNAL_FUNC(terminal_line_changed), NULL);
	gtk_container_add(GTK_CONTAINER(frame), GTK_WIDGET(term));

	term->normal_fg = normal_fg;
	term->normal_bg = normal_bg;
	term->silent = silent;
	term->auto_linefeed = auto_linefeed;
	term->use_bold = use_bold;
	term->use_under = use_under;
	term->can_block = can_block;
	keymap_init(term);

	gtk_widget_show(GTK_WIDGET(term));
	gtk_widget_grab_focus(GTK_WIDGET(term));


	gtk_signal_connect(GTK_OBJECT(term->adjustment), "value_changed",
		GTK_SIGNAL_FUNC(scrollbar_move_callback), term);
	term->scrollbar = gtk_vscrollbar_new(term->adjustment);
	gtk_box_pack_end(GTK_BOX(box), term->scrollbar, FALSE, FALSE, 0);
	gtk_widget_show(term->scrollbar);


	control_box = gtk_vbox_new(FALSE, 5);
	gtk_box_pack_end(GTK_BOX(hbox), control_box, FALSE, FALSE, 0);
	control_bar(control_box);
	gtk_widget_show(control_box);

	status_box = gtk_hbox_new(FALSE, 5);
	gtk_box_pack_end(GTK_BOX(main_box), status_box, FALSE, FALSE, 0);
	status_bar(status_box);
	gtk_widget_show(status_box);

	separator = gtk_hseparator_new();
	gtk_box_pack_end(GTK_BOX(main_box), separator, FALSE, FALSE, 0);
	gtk_widget_show(separator);

	bottom_frame = frame = gtk_hbox_new(FALSE, 0);
	// gtk_frame_new(NULL);
	gtk_box_pack_end(GTK_BOX(main_box), frame, FALSE, FALSE, 0);
	gtk_widget_show(frame);

	if(use_modem) {
		main_bottom_menu = current_bottom_menu =
			main_bottom_menu_create(expand_path(MAIN_BOTTOM_MENU_FILE));
	} else {
		main_bottom_menu = current_bottom_menu =
			main_bottom_menu_create(expand_path(TCP_MAIN_BOTTOM_MENU_FILE));
	}

	if(current_bottom_menu != NULL) 
		gtk_container_add(GTK_CONTAINER(frame), current_bottom_menu);
	
	/*
	if(use_modem)
		connected_function_list = g_list_append(connected_function_list,
			update_bottom_menu);
	else
		connected_function_list = g_list_append(connected_function_list,
			update_telnet_bottom_menu);
	*/

	if(sound_flag) 
		connected_function_list = g_list_append(connected_function_list,
			play_connect);
	connected_function_list = g_list_append(connected_function_list,
		taegeuk_start);
	disconnected_function_list = g_list_append(
		disconnected_function_list, restore_main_bottom_menu);
	if(sound_flag) 
		disconnected_function_list = g_list_append(
			disconnected_function_list, play_disconnect);
	disconnected_function_list = g_list_append(
		disconnected_function_list, taegeuk_stop);
	signal(SIGCHLD, SIG_IGN);

	gtk_widget_show(main_win);

	//resize_increment_set(main_win, term);

	if(!use_modem) putenv("TERM=vt100");
	gtk_main();
	if(sound_flag) play_exit();
	if(use_modem && do_lock) modem_unlock(NULL);
	fclose(log_file);
	return 0;
}

void
input_handler(gpointer data, int source, GdkInputCondition con)
{
	int size;
	char buf[256];
	size = read(source, buf, 255);
	if(size)term->to_term(term, buf, size);
}

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <gdk/gdkprivate.h>
void
resize_increment_set(GtkWidget *w, AnsiTerm *term)
{
	XSizeHints size_hints;
	GdkWindowPrivate *private;
	size_hints.width_inc = term->font_width;
	size_hints.height_inc = term->font_height;
	size_hints.flags = PResizeInc;
	private = (GdkWindowPrivate*)w->window;
	XSetWMNormalHints(private->xdisplay, private->xwindow, &size_hints);
}

void
terminal_size_changed(AnsiTerm *term)
{
	if(read_fd > 0 && !use_modem) pty_setwinsize(read_fd, term->col, term->row);
}

void
terminal_line_changed(AnsiTerm *term)
{
	auto_response_check(term->buf + term->col*linenumber(term->cu_y), term->cu_x);
}
