#ifndef __GAU_H__
#define __GAU_H__
#include <stdio.h>
#include <gtk/gtk.h>
#include "phone.h"
#include "ansiterm.h"

enum { SCRIPT, DIAL, DOWNLOAD, UPLOAD, NOTHING, CONNECTED, TELNET, TELNET_DIAL};

typedef struct 
{ 
	char *name, *host, *port, *script_file;
} TelnetInfo;

typedef struct { 
	char *lpattern; 
	int jm[256]; 
	int llen;
	GList *ilist, *olist; 
	char *raw; 
	int type; 
	gboolean active;
} Auto;

extern Auto *inouts;
extern int n_inout;
extern FILE *log_file;
extern int gau_state;
extern AnsiTerm *term;
extern char tmpbuf[];
extern GtkWidget *taegeuk;
extern char *editor;
extern char *sh_command;
extern GList *disconnected_function_list;
extern GList *connected_function_list;
extern PhoneItem *current_item;
extern int use_internal_rz;
extern int local_echo, remote_echo;
extern int strip_linefeed;
extern int auto_linefeed;
extern int use_internal_telnet;
extern int can_block;
extern char *modem_device;
extern char *modem_speed;
extern char *modem_parity;
extern char *modem_bits;
extern int modem_use_hwf;
extern int modem_use_swf;
extern GdkColor *color_table[8];
extern GtkWidget *main_bottom_menu, *bottom_frame;
extern GtkWidget *current_bottom_menu;
extern GtkWidget *hangup_after_transfer_button;
extern GtkWidget *call_button, *upload_button;
extern GtkWidget *capture_button;
extern GtkWidget *write_button;
extern GtkWidget *main_win;
extern GtkWidget *chat_win;
extern int sound_flag;
extern int use_modem;
extern int terminal_font_ascent, terminal_font_height;
extern char *terminal_font;
extern GList *input_filter_list;
extern int read_tag;
extern int read_fd;
extern int telnet_pid;
extern char *sz_command;
extern char *telnet_command;
extern char *ftp_command, *http_command;
extern char *initialize_string;
extern int capture_fd;
extern int scapture_fd;
extern int read_hack;
extern char *script_path;
extern char *gau_path;
extern char *capture_path;
extern char *capture_file;
extern gboolean exit_after_download;
extern gboolean do_lock;
extern TelnetInfo *telnetinfo;
extern guint32 last_out_time;
extern guint32 last_incoming_time;
extern int silent;
extern GdkColor *black, *red, *green, *yellow, *blue, *magenta, *cyan, *white;
extern int normal_fg, normal_bg;
extern int idle_guard_interval;
extern int use_ztelnet;
extern int use_under;
extern int use_bold;
extern int chat_append;
extern char *chat_prefix1;
extern char *chat_prefix2;
extern char *chat_suffix;
extern int saved_lines;
extern int col, row;
extern GList *telnetinfo_list;

void control_bar(GtkWidget *w);
void status_bar(GtkWidget *w);
void dial_callback(GtkWidget *w, gpointer data);
void hangup_callback(GtkWidget *w, gpointer data);

void hangup(void);
GtkWidget *string_file_read(char *);
void scrollbar_move_callback(GtkWidget *w, AnsiTerm *);
void gau_config(void);
void si_callback(GtkWidget *w, gpointer foo);
void phone_win(void);
void dial_cancel(void);
void script_cancel(void);
char *expand_path(char *);
char *get_line(FILE *fp);
void destroy_script(void);
int modem_connected(void);
void modem_hangup(void);
int modem_restore(void);
void modem_setbaud(int modemfd, char *);
int modem_unlock(char *device);
int modem_lock(char *device);
void update_bottom_menu_from_file(char *filename);
void restore_main_bottom_menu(void);

void run_login_script(void);
void run_script_from_file(char *filename);
void run_script_from_string(char *str);
void run_script_from_command(char *command);

GtkWidget * main_bottom_menu_create(char *filename);
void call_callback(GtkWidget *, Phone *); 
void phone_win(void);
void dial_phone(PhoneItem *item);

void play_end(void);
void play_connect(void);
void play_disconnect(void);
void play_click(void);
void play_transfer_end(void);
void play_exit(void);
void play(char *);

GtkWidget * ani_pixmap_create(GtkWidget *w);
void taegeuk_start(void);
void taegeuk_stop(void);

void zmodem_input_handler(gpointer, int , GdkInputCondition);
void run_rz(void);
void run_sz(void);
void rz_cancel(void);
void sz_cancel(void);
void run_internal_rz(void);
void end_internal_rz(void);
void zmodem_init(void);
int zmodem_input_filter(char *str, int bytes);

void input_handler_from_external(gpointer data, int source, GdkInputCondition con);
void fast_input_handler_from_external(gpointer data, int source, GdkInputCondition con);

int telnet_write(char *, int);
int telnet_write_byte(char );
int telnet_connected(void);
void telnet_connect(char *host, char *port, char *script);
void telnet_hangup(void);
void telnet_child_signal(int sig);
int telnet_time_report(gpointer foo);
int dumb(char *buf, int byte);
void pty_setwinsize(int fd, int col, int row);

void begin_capture(char *filename);
void end_capture(void);
void screen_save(void);
int capture_input_filter(char *str, int bytes);

char *eat_space(char *);

void show_time(int);
void show_message(char *);
void append_message(char *);

void delayed_transmit(char *buf , int size, int msec);
void window_destroyed(GtkWidget *w, GtkWidget **win);

void delayed_run(guint32 msec, void (*func)(void));
void auto_response_prepare(void);
int auto_response_check(char *str, int size);
char * transform_string(char *s, char **d);
gint connect_host_by_name(char *host);
void show_incoming(gboolean flag);
void show_outgoing(gboolean flag);
#endif /* __GAU_H__ */
