#include <gtk/gtk.h>

#include "gzillaimgsink.h"

#undef DISABLE_ALL_IMGSINK

gint
gzilla_imgsink_bpp (GzillaImgType type)
{
  switch (type) {
  case GZILLA_IMG_TYPE_INDEXED:
    return 1;
  case GZILLA_IMG_TYPE_RGB:
    return 3;
  case GZILLA_IMG_TYPE_GRAY:
    return 1;
  }
  return 0;
}

void
gzilla_imgsink_write (GzillaImgSink *imgsink,
		      char *buf,
		      gint x,
		      gint y,
		      gint stride)
{
#ifdef DISABLE_ALL_IMGSINK
  return;
#endif
  imgsink->write (imgsink, buf, x, y, stride);
}


void
gzilla_imgsink_close (GzillaImgSink *imgsink)
{
#ifdef DISABLE_ALL_IMGSINK
  return;
#endif
  imgsink->close (imgsink);
}


void
gzilla_imgsink_abort (GzillaImgSink *imgsink)
{
#ifdef DISABLE_ALL_IMGSINK
  return;
#endif
  imgsink->abort (imgsink);
}


void
gzilla_imgsink_set_parms (GzillaImgSink *imgsink,
			  gint width,
			  gint height,
			  GzillaImgType type)
{
  extern void image_set(int, int);
#ifdef DISABLE_ALL_IMGSINK
  return;
#endif
  imgsink->set_parms (imgsink, width, height, type);
  image_set(width, height);
}

void
gzilla_imgsink_set_cmap (GzillaImgSink *imgsink,
			 guchar *cmap,
			 gint num_colors,
			 gint bg_index)
{
#ifdef DISABLE_ALL_IMGSINK
  return;
#endif
  imgsink->set_cmap (imgsink, cmap, num_colors, bg_index);
}
