#ifndef __GZILLA_IMG_SINK_H__
#define __GZILLA_IMG_SINK_H__

/* This is a stub for the real GzillaImgSink data structure, which
   will happen later. */

typedef struct _GzillaImgSink GzillaImgSink;

typedef enum {
  GZILLA_IMG_TYPE_INDEXED,
  GZILLA_IMG_TYPE_RGB,
  GZILLA_IMG_TYPE_GRAY
} GzillaImgType;

struct _GzillaImgSink {
  void (* write) (GzillaImgSink *imgsink,
		  char *buf,
		  gint x,
		  gint y,
		  gint stride);
  void (* close) (GzillaImgSink *imgsink);
  void (* abort) (GzillaImgSink *imgsink);
  void (* set_parms) (GzillaImgSink *imgsink,
		      gint width,
		      gint height,
		      GzillaImgType type);
  void (* set_cmap) (GzillaImgSink *imgsink,
		     guchar *cmap,
		     gint num_colors,
		     gint bg_index);
};

gint gzilla_imgsink_bpp       (GzillaImgType type);
void gzilla_imgsink_write     (GzillaImgSink *imgsink,
			       char *buf,
			       gint x,
			       gint y,
			       gint stride);
void gzilla_imgsink_close     (GzillaImgSink *imgsink);
void gzilla_imgsink_abort     (GzillaImgSink *imgsink);
void gzilla_imgsink_set_parms (GzillaImgSink *imgsink,
			       gint width,
			       gint height,
			       GzillaImgType type);
void gzilla_imgsink_set_cmap  (GzillaImgSink *imgsink,
			       guchar *cmap,
			       gint num_colors,
			       gint bg_index);

/* Note: the imgsink methods are always called in the following order:
   set_parms
   set_cmap, iff type in set_parms call was GZILLA_IMG_TYPE_INDEXED
   write, any number of times
   close | abort

   The close and abort methods are responsible for freeing all
   internal state and the imgsink itself. */

#endif /* __GZILLA_IMG_SINK__ */
