
/* this file is a part of gau software, (C) Hwang chi-duck 1997               */

#include <gtk/gtk.h>
#include <gdk/automata.h>
#include "fixedlabel.h"

extern char tmpbuf[];
GtkWidget *status_label;
GtkWidget *time_label;
GtkWidget *han_input_label;

extern void (*automata_hangul_input_state_changed)(void);
void han_input_state_show(void) 
{
	if(hangul_input()) fixed_label_set(FIXED_LABEL(han_input_label), " ѱ ");
	else fixed_label_set(FIXED_LABEL(han_input_label), "  ");
}

void
status_bar(GtkWidget *box)
{
	GtkWidget *frame;
	automata_hangul_input_state_changed = han_input_state_show;

	status_label = fixed_label_new("");
	gtk_widget_set_name(status_label, "status-label");
	gtk_box_pack_start(GTK_BOX(box), status_label, FALSE, FALSE, 2);
	gtk_misc_set_alignment(GTK_MISC(status_label), 0.0, 0.5);
	gtk_widget_show(status_label);

	// time
	frame = gtk_frame_new(NULL);
	gtk_frame_set_shadow_type(GTK_FRAME(frame), GTK_SHADOW_ETCHED_IN);
	gtk_box_pack_end(GTK_BOX(box), frame, FALSE, FALSE, 5);
	gtk_widget_show(frame);
	time_label = fixed_label_new(" 00:00 ");
	gtk_widget_set_name(time_label, "time-label");
	gtk_container_add(GTK_CONTAINER(frame), time_label);
	gtk_widget_show(time_label);

	// han input state
	frame = gtk_frame_new(NULL);
	gtk_frame_set_shadow_type(GTK_FRAME(frame), GTK_SHADOW_ETCHED_IN);
	gtk_box_pack_end(GTK_BOX(box), frame, FALSE, FALSE, 5);
	gtk_widget_show(frame);

	han_input_label = fixed_label_new("  ");
	gtk_widget_set_name(han_input_label, "han-label");
	gtk_container_add(GTK_CONTAINER(frame), han_input_label);
	han_input_state_show();
	gtk_widget_show(han_input_label);

	// in & out status report
#if 0
	in_pixmap[0] = ;
	in_pixmap[1] = ;
	out_pixmap[0] = ;
	out_pixmap[1] = ;
#endif
}

void
append_message(char *buf)
{
	char *orig;
	fixed_label_get(FIXED_LABEL(status_label), &orig);
	sprintf(tmpbuf, "%s %s", orig, buf);
	fixed_label_set(FIXED_LABEL(status_label), tmpbuf);
}

void
show_message(char *buf)
{
	fixed_label_set(FIXED_LABEL(status_label), buf);
}

void
show_time(int second)
{
	char tmp_buf[6];
	sprintf(tmp_buf, " %02d:%02d ", second/60, second%60);
	fixed_label_set(FIXED_LABEL(time_label), tmp_buf);
}

void
show_incoming(gboolean flag)
{
}

void
show_outgoing(gboolean flag)
{
}

