#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <sys/time.h>
#include <sys/types.h>
#include <signal.h> // for signal
#include <sys/types.h>
#include <sys/wait.h> // for wait
#include <gtk/gtk.h>

#include "gau.h"
#include "ansiterm.h"

void prepare_telnet_script(char *script_file);

void telnet_done(void);
int telnet(char *host, char *port, int col, int row);
typedef void SimpleFunction(void);


int use_internal_telnet = FALSE;
int telnet_pid = -1;
static int time_tick = 0;
static guint32 connect_time = 0;


int
tcp_write(char *buf, int byte)
{

	last_out_time = gdk_time_get();
	if(local_echo) term->to_term(term, buf, byte);
	write(read_fd, buf, byte);
	return byte;
}

int
tcp_write_byte(char c)
{
	if(local_echo) term->to_term(term, &c, 1);
	write(read_fd, &c, 1);
	return 1;
}


void
telnet_hangup(void)
{
	if(read_fd < 0) return;
	if(use_internal_telnet) {
		close(read_fd);
		read_fd = -1;
	} else {
		kill(telnet_pid, SIGTERM);
	}
}

int
telnet_connected(void)
{
	if(read_fd != -1) return TRUE;
	else return FALSE;
}

int
telnet_check_connected(char *buf, int size)
{
	static char tcp_connect_string[] = "Escape";
	static char *p = tcp_connect_string;
	GList *list;
	int i;
	for(i=0;i<size;i++) {
		if(buf[i] != *p) p = tcp_connect_string;
		else if(*++p == '\0') {
			time_t timep;
			struct tm *lt;
			input_filter_list = 
				g_list_remove(input_filter_list, telnet_check_connected);
			// connected 
			gtk_widget_set_sensitive(write_button, TRUE);
			gtk_label_set(GTK_LABEL(GTK_BUTTON(call_button)->child), 
				"");
			gau_state = TELNET;
			sprintf(tmpbuf, "%s  Ǿϴ.", 
				telnetinfo?telnetinfo->name:"???");
			show_message(tmpbuf);
			fprintf(log_file, "=====================================================\n");
			if(telnetinfo) {
				fprintf(log_file, "%s: %s\n", telnetinfo->name, telnetinfo->host);
			} else {
				fprintf(log_file, "ϾȵȰ\n");
			}
			timep = time(NULL);
			lt = localtime(&timep);
			sprintf(tmpbuf, ":%02d %02d %02d %02d %02d",lt->tm_mon + 1, lt->tm_mday,
			lt->tm_hour, lt->tm_min, lt->tm_sec); 
			fprintf(log_file,"%s\n", tmpbuf);
			list = connected_function_list;
			while(list) {
				SimpleFunction *func = list->data;
				//g_print("connected fun: %p\n", list->data);
				(*func)();
				list = list->next;
			}
			sprintf(tmpbuf, ": %s", telnetinfo?telnetinfo->name:"???");
			gtk_window_set_title(GTK_WINDOW(main_win), tmpbuf);
			gtk_timeout_add(1000, telnet_time_report, NULL);
			connect_time = gdk_time_get();
			return TRUE;
		}
	}
	return TRUE;
}

void
telnet_connect(char *host, char *port, char *script)
{
	//g_print("%s %s %s\n", host, port, script);
	sprintf(tmpbuf, "%s  õմϴ", host); 
	gau_state = TELNET_DIAL;
	show_message(tmpbuf);
	read_fd = telnet(host, port, term->col, term->row);
	prepare_telnet_script(script);
	if(read_hack) {
		read_tag = gdk_input_add(read_fd, GDK_INPUT_READ, 
			fast_input_handler_from_external, NULL);
	} else {
		read_tag = gdk_input_add(read_fd, GDK_INPUT_READ, 
			input_handler_from_external, NULL);
	}
	input_filter_list = 
		g_list_prepend(input_filter_list, telnet_check_connected);
	term->from_term = tcp_write;
}



void telnet_child_signal(int sig);
int pty_open(char *, int *, int , int);


// return value: file descripter of gate for telnet
int
telnet(char *host, char *port, int col, int row)
{
	char telnet_command_buf[256];
	sprintf(telnet_command_buf, "%s %s ", telnet_command, host);
	if(port != NULL && port[0] != '0') {
		strcat(telnet_command_buf, port);
	}
	signal(SIGCHLD, telnet_child_signal);
	return pty_open(telnet_command_buf, &telnet_pid, col, row);
}

void
telnet_child_signal(int sig)
{
	if(wait(NULL) != telnet_pid) {
		signal(SIGCHLD, telnet_child_signal);
		return;
	}
	telnet_done();
}

void
telnet_done(void)
{
	GList *list;
	if(gau_state == SCRIPT) script_cancel();
	gau_state = NOTHING;
	// telnet client exited
	signal(SIGCHLD, SIG_IGN);
	input_filter_list = 
		g_list_remove(input_filter_list, telnet_check_connected);
	telnet_pid = -1;
	close(read_fd);
	read_fd = -1;
	gdk_input_remove(read_tag);
	read_tag = -1;
	term->from_term = dumb;
	list = disconnected_function_list;
	while(list) {
		SimpleFunction *func = list->data;
		//g_print("disconnected fun: %p\n", list->data);
		(*func)();
		list = list->next;
	}
	gtk_window_set_title(GTK_WINDOW(main_win), "");
#ifdef UPLOAD_BUTTON
	gtk_widget_set_sensitive(upload_button, FALSE);
#endif
	gtk_label_set(GTK_LABEL(GTK_BUTTON(call_button)->child), "ϱ");
}

int
dumb(char *buf, int byte)
{
	return 0;
}

int
telnet_time_report(gpointer foo)
{
	guint32 current_time = gdk_time_get();
	int new_tick;
	
	new_tick = (current_time - connect_time)/1000;
	if(new_tick != time_tick) {
		show_time(time_tick);
		time_tick = new_tick;
	}
	if(read_fd > 0) {
		if((last_out_time + idle_guard_interval) < current_time) {
			//g_print("idle_guard\n");
			term->from_term(" ", 2);
		}
		if((last_incoming_time + 500) < current_time) {
			auto_response_check(term->buf + term->col*linenumber(term->cu_y), 
				term->cu_x);
			last_incoming_time = current_time + 400000;
		}
		return TRUE;
	}
	// connection lost
	fprintf(log_file, "ȭð:%d %d\n", time_tick/60, time_tick%60);
	sprintf(tmpbuf, "̹ ð %d %dԴϴ", time_tick/60, time_tick%60);
	show_message(tmpbuf);
	time_tick = -1;
	return FALSE;
}

gint
connect_host_by_name(char *host)
{
	GList *list = telnetinfo_list;
	TelnetInfo *ti;
	while(list) {
		ti = list->data;
		if(strcmp(ti->host, host) == 0 || strcmp(ti->name, host) == 0) {
			break;
		}
		list = list->next;
	}
	if(list) {
		telnet_connect(ti->host, ti->port, ti->script_file);
		telnetinfo = ti;
	} else {
		telnetinfo = NULL;
		telnet_connect(host, NULL, NULL);
	}
	return FALSE;
}

